%global namedreltag .RELEASE
%global namedversion %{version}%{?namedreltag}

%global pom_url http://repo1.maven.org/maven2/org/springframework

Name:          springframework4
Version:       4.1.9
Release:       1%{?dist}
Summary:       Spring Java Application Framework
License:       ASL 2.0
URL:           http://projects.spring.io/spring-framework/
Source0:       https://github.com/spring-projects/spring-framework/archive/v%{namedversion}/%{name}-%{namedversion}.tar.gz

Source100:     %{pom_url}/spring-aop/%{namedversion}/spring-aop-%{namedversion}.pom
Source101:     %{pom_url}/spring-beans/%{namedversion}/spring-beans-%{namedversion}.pom
Source102:     %{pom_url}/spring-context/%{namedversion}/spring-context-%{namedversion}.pom
Source103:     %{pom_url}/spring-context-support/%{namedversion}/spring-context-support-%{namedversion}.pom
Source104:     %{pom_url}/spring-core/%{namedversion}/spring-core-%{namedversion}.pom
Source105:     %{pom_url}/spring-expression/%{namedversion}/spring-expression-%{namedversion}.pom
Source106:     %{pom_url}/spring-instrument/%{namedversion}/spring-instrument-%{namedversion}.pom
Source107:     %{pom_url}/spring-jdbc/%{namedversion}/spring-jdbc-%{namedversion}.pom
Source108:     %{pom_url}/spring-jms/%{namedversion}/spring-jms-%{namedversion}.pom
Source109:     %{pom_url}/spring-messaging/%{namedversion}/spring-messaging-%{namedversion}.pom
Source110:     %{pom_url}/spring-orm/%{namedversion}/spring-orm-%{namedversion}.pom
Source111:     %{pom_url}/spring-oxm/%{namedversion}/spring-oxm-%{namedversion}.pom
Source112:     %{pom_url}/spring-test/%{namedversion}/spring-test-%{namedversion}.pom
Source113:     %{pom_url}/spring-tx/%{namedversion}/spring-tx-%{namedversion}.pom
Source114:     %{pom_url}/spring-web/%{namedversion}/spring-web-%{namedversion}.pom
Source115:     %{pom_url}/spring-webmvc/%{namedversion}/spring-webmvc-%{namedversion}.pom
Source116:     %{pom_url}/spring-webmvc-portlet/%{namedversion}/spring-webmvc-portlet-%{namedversion}.pom
Source117:     %{pom_url}/spring-websocket/%{namedversion}/spring-websocket-%{namedversion}.pom

# Customized pom file
# Some project use these classes.
Source200:     spring-orm-hibernate-template.pom

Patch0:        springframework-4.1.9-remove-hibernate-validator4-support.patch
Patch1:        springframework-4.1.9-port-spring-tx-to-javax.resources-1.7.patch
Patch2:        springframework-4.1.9-port-spring-web-to-protobuf-java-format-1.4.patch
Patch3:        springframework-4.1.9-port-spring-web-to-servlet-3.1.patch
Patch4:        springframework-4.1.9-port-spring-jms-to-javax.resources-1.7.patch
# Remove Tiles 2.2.2/3.0.5 support. Soon will retire tiles package
Patch5:        springframework-4.1.9-spring-webmvc-remove-tiles2-and-tiles3-support.patch
Patch6:        springframework-4.1.9-port-spring-webmvc-to-velocity-tools-2.patch
Patch7:        springframework-4.1.9-port-spring-webmvc-to-servlet-3.1.patch

Patch8:        springframework-4.1.9-port-spring-test-to-servlet-3.1.patch
# Not available build deps use reactor == 1.1.6.RELEASE
Patch9:        springframework-4.1.9-remove-reactor-support.patch
# Add Tyrus 1.7+ support
Patch10:       springframework-4.1.9-remove-tyrus-1.3.5-support.patch
# Add Jetty 9.3 support
Patch11:       springframework-4.1.9-port-spring-websocket-to-jetty-9.3.patch

BuildRequires: maven-local
BuildRequires: mvn(aopalliance:aopalliance)
BuildRequires: mvn(com.caucho:hessian)
BuildRequires: mvn(com.fasterxml.jackson.core:jackson-databind)
BuildRequires: mvn(com.fasterxml.jackson.dataformat:jackson-dataformat-xml)
BuildRequires: mvn(com.google.code.gson:gson)
BuildRequires: mvn(com.google.guava:guava)
BuildRequires: mvn(com.google.protobuf:protobuf-java)
BuildRequires: mvn(com.googlecode.protobuf-java-format:protobuf-java-format)
BuildRequires: mvn(com.h2database:h2)
BuildRequires: mvn(com.jamonapi:jamon)
BuildRequires: mvn(com.jayway.jsonpath:json-path)
BuildRequires: mvn(com.lowagie:itext)
BuildRequires: mvn(com.mchange:c3p0)
BuildRequires: mvn(com.thoughtworks.xstream:xstream)
BuildRequires: mvn(commons-codec:commons-codec)
BuildRequires: mvn(commons-fileupload:commons-fileupload)
BuildRequires: mvn(commons-logging:commons-logging)
BuildRequires: mvn(commons-pool:commons-pool)
BuildRequires: mvn(io.netty:netty-all)
BuildRequires: mvn(javax.ejb:ejb-api)
BuildRequires: mvn(javax.el:javax.el-api)
BuildRequires: mvn(javax.enterprise.concurrent:javax.enterprise.concurrent-api)
BuildRequires: mvn(javax.inject:javax.inject)
BuildRequires: mvn(javax.jdo:jdo-api)
BuildRequires: mvn(javax.mail:javax.mail-api)
BuildRequires: mvn(javax.portlet:portlet-api)
BuildRequires: mvn(javax.servlet:javax.servlet-api)
BuildRequires: mvn(javax.servlet.jsp:javax.servlet.jsp-api)
BuildRequires: mvn(javax.transaction:javax.transaction-api)
BuildRequires: mvn(javax.websocket:javax.websocket-api)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(joda-time:joda-time)
BuildRequires: mvn(log4j:log4j:1.2.17)
BuildRequires: mvn(net.sf.cglib:cglib)
BuildRequires: mvn(net.sf.ehcache.internal:ehcache-core:2.10)
BuildRequires: mvn(net.sf.jasperreports:jasperreports)
BuildRequires: mvn(net.sf.jopt-simple:jopt-simple)
BuildRequires: mvn(net.sourceforge.jexcelapi:jxl)
BuildRequires: mvn(org.apache.derby:derby)
BuildRequires: mvn(org.apache.derby:derbyclient)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-commonj_1.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-interceptor_3.0_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jcache_1.0_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-jms_1.1_spec)
BuildRequires: mvn(org.apache.geronimo.specs:geronimo-validation_1.0_spec)
BuildRequires: mvn(org.apache.geronimo.specs:specs-parent:pom:)
BuildRequires: mvn(org.apache.httpcomponents:httpasyncclient)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.openjpa:openjpa-lib)
BuildRequires: mvn(org.apache.openjpa:openjpa-persistence-jdbc)
BuildRequires: mvn(org.apache.poi:poi)
BuildRequires: mvn(org.apache.taglibs:taglibs-standard-jstlel)
BuildRequires: mvn(org.apache.taglibs:taglibs-standard-spec)
BuildRequires: mvn(org.apache.tomcat:tomcat-websocket)
BuildRequires: mvn(org.apache.velocity:velocity)
BuildRequires: mvn(org.apache.xmlbeans:xmlbeans)
BuildRequires: mvn(org.aspectj:aspectjweaver)
BuildRequires: mvn(org.beanshell:bsh)
BuildRequires: mvn(org.codehaus.castor:castor-xml)
BuildRequires: mvn(org.codehaus.gmavenplus:gmavenplus-plugin)
BuildRequires: mvn(org.codehaus.groovy:groovy-all)
BuildRequires: mvn(org.eclipse.jetty:jetty-client)
BuildRequires: mvn(org.eclipse.jetty:jetty-server)
BuildRequires: mvn(org.eclipse.jetty:jetty-servlet)
BuildRequires: mvn(org.eclipse.jetty:jetty-webapp)
BuildRequires: mvn(org.eclipse.jetty.websocket:websocket-client)
BuildRequires: mvn(org.eclipse.jetty.websocket:websocket-server)
BuildRequires: mvn(org.eclipse.persistence:javax.persistence)
BuildRequires: mvn(org.eclipse.persistence:org.eclipse.persistence.core)
BuildRequires: mvn(org.eclipse.persistence:org.eclipse.persistence.jpa)
BuildRequires: mvn(org.freemarker:freemarker)
BuildRequires: mvn(org.glassfish.tyrus:tyrus-container-servlet)
BuildRequires: mvn(org.glassfish.tyrus:tyrus-core)
BuildRequires: mvn(org.glassfish.tyrus:tyrus-server)
BuildRequires: mvn(org.glassfish.tyrus:tyrus-spi)
BuildRequires: mvn(org.hamcrest:hamcrest-core)
BuildRequires: mvn(org.hibernate:hibernate-core:3)
BuildRequires: mvn(org.hibernate:hibernate-core:4)
BuildRequires: mvn(org.hibernate:hibernate-entitymanager:3)
BuildRequires: mvn(org.hibernate:hibernate-entitymanager:4)
BuildRequires: mvn(org.hibernate:hibernate-validator)
BuildRequires: mvn(org.hibernate.javax.persistence:hibernate-jpa-2.1-api)
BuildRequires: mvn(org.hsqldb:hsqldb)
BuildRequires: mvn(org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec)
BuildRequires: mvn(org.jboss.spec.javax.resource:jboss-connector-api_1.7_spec)
BuildRequires: mvn(org.jibx:jibx-run)
BuildRequires: mvn(org.jruby:jruby)
BuildRequires: mvn(org.objenesis:objenesis)
BuildRequires: mvn(org.quartz-scheduler:quartz)
BuildRequires: mvn(org.skyscreamer:jsonassert)
BuildRequires: mvn(org.testng:testng)
BuildRequires: mvn(org.yaml:snakeyaml)
BuildRequires: mvn(velocity-tools:velocity-tools-view)
BuildRequires: mvn(xmlunit:xmlunit)

%if %{?fedora} > 24
BuildRequires: mvn(com.rometools:rome)
%else
BuildRequires: mvn(rome:rome)
%endif

BuildArch:     noarch

%description
Spring is a layered Java/J2EE application framework, based on code published in
Expert One-on-One J2EE Design and Development by Rod Johnson (Wrox, 2002).

%package aop
Summary:       Spring Aspect Oriented Framework

%description aop
Spring AOP is an enabling technology that allows the implementation of custom
aspects and provides declarative transaction management without EJB.

%package beans
Summary:       Spring Bean Factory

%description beans
The Spring Bean Factory provides an advanced configuration mechanism capable of
managing beans of any nature, using potentially any kind of storage facility.

%package context
Summary:       Spring Application Context

%description context
The Spring Application Context is a complete superset of a bean factory, and
adds enhanced capabilities to it, some of them more J2EE and
enterprise-centric.

%package context-support
Summary:       Spring Context Support

%description context-support
This package provide Quartz/CommonJ scheduling,
UI templating, mail and caching.

%package core
Summary:       Spring Core

%description core
This package provide Quartz/CommonJ scheduling,
UI templating, mail and caching.

%package expression
Summary:       Spring Expression Language (SpEL)

%description expression
The Spring Expression Language (SpEL for short) is a powerful expression
language that supports querying and manipulating an object graph at runtime.

%package instrument
Summary:       Spring Instrumentation

%description instrument
The Spring Instrumentation Framework exposes performance and
resource utilization metrics for the Spring container and
gives you runtime control of the container.

%package jdbc
Summary:       Spring JDBC

%description jdbc
Spring JDBC takes care of all the low-level details associated to the
development with JDBC.

%package jms
Summary:       Spring jms

%description jms
This package provide Java Message Service 1.0.2/1.1 support.

%package messaging
Summary:       Spring Messaging

%description messaging
This package provide support for messaging architectures and protocols.

%package orm
Summary:       Spring ORM

%description orm
This package provide JDO support, JPA support, Hibernate
support, TopLink support.

%package orm-hibernate4
Summary:       Spring ORM Hibernate 4 Support

%description orm-hibernate4
This package provide Hibernate 4 support.

%package oxm
Summary:       Spring OXM

%description oxm
This package provide marshaling and unmarshalling
for XML with JAXB context and JiBX binding factories.

%package test
Summary:       Spring test context framework

%description test
Spring's test context framework. Also includes common Servlet and
Portlet API mocks.

%package tx
Summary:       Spring Transaction Management

%description tx
Spring provides a consistent abstraction for transaction management that
provides a consistent programming model across different transaction APIs,
supports declarative transaction management, provides a simpler API for
programmatic transaction management and integrates with Spring's various data
access abstractions.

%package web
Summary:       Spring Web

%description web
This package provide web application context, multipart
resolver, HTTP-based remoting support.

%package webmvc
Summary:       Spring Web Servlet

%description webmvc
This package provide framework servlets, web MVC framework,
web controllers, web views for JSP, Velocity, Tiles,
iText and POI.

%package webmvc-portlet
Summary:       Spring Web Portlet

%description webmvc-portlet
This package provide support development of Portlet
applications with Spring.

%package websocket
Summary:       Spring WebSocket

%description websocket
Spring Framework’s support for WebSocket-style messaging
in web applications including use of STOMP as an
application level WebSocket sub-protocol.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n spring-framework-%{namedversion}
# Cleanup
find .  -name "*.jar" -print -delete
find .  -name "*.class" -print -delete

# This is a dummy POM added just to ease building in the RPM platforms
cat > pom.xml << EOF
<?xml version="1.0" encoding="UTF-8"?>
<project
  xmlns="http://maven.apache.org/POM/4.0.0"
  xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
  <modelVersion>4.0.0</modelVersion>
  <groupId>org.springframework</groupId>
  <artifactId>spring-project</artifactId>
  <packaging>pom</packaging>
  <version>%{namedversion}</version>
  <modules>
    <module>spring-aop</module>
    <module>spring-beans</module>
    <module>spring-context</module>
    <module>spring-context-support</module>
    <module>spring-core</module>
    <module>spring-expression</module>
    <module>spring-instrument</module>
    <!-- Unwanted module >spring-instrument-tomcat</module-->
    <module>spring-jdbc</module>
    <module>spring-jms</module>
    <module>spring-test</module>
    <module>spring-tx</module>
    <module>spring-messaging</module>
    <module>spring-orm</module>
    <module>spring-oxm</module>
    <!-- Unwanted module >spring-struts</module-->
    <module>spring-web</module>
    <module>spring-webmvc</module>
    <module>spring-webmvc-portlet</module>
    <module>spring-websocket</module>
  </modules>
</project>
EOF

cp -p %{SOURCE100} spring-aop/pom.xml
cp -p %{SOURCE101} spring-beans/pom.xml
cp -p %{SOURCE102} spring-context/pom.xml
cp -p %{SOURCE103} spring-context-support/pom.xml
cp -p %{SOURCE104} spring-core/pom.xml
cp -p %{SOURCE105} spring-expression/pom.xml
cp -p %{SOURCE106} spring-instrument/pom.xml
cp -p %{SOURCE107} spring-jdbc/pom.xml
cp -p %{SOURCE108} spring-jms/pom.xml
cp -p %{SOURCE109} spring-messaging/pom.xml
cp -p %{SOURCE110} spring-orm/pom.xml
cp -p %{SOURCE111} spring-oxm/pom.xml
cp -p %{SOURCE112} spring-test/pom.xml
cp -p %{SOURCE113} spring-tx/pom.xml
cp -p %{SOURCE114} spring-web/pom.xml
cp -p %{SOURCE115} spring-webmvc/pom.xml
cp -p %{SOURCE116} spring-webmvc-portlet/pom.xml
cp -p %{SOURCE117} spring-websocket/pom.xml

cp -p %{SOURCE200} spring-orm-hibernate4/pom.xml
%pom_xpath_set "pom:project/pom:artifactId" "spring-orm-hibernate4" spring-orm-hibernate4
%pom_xpath_set "pom:project/pom:version" %{namedversion} spring-orm-hibernate4
%pom_xpath_set "pom:properties/pom:hibernate.version" 4 spring-orm-hibernate4
%pom_xpath_inject "pom:modules" "<module>spring-orm-hibernate4</module>"

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%pom_remove_dep ::3.0.5 spring-webmvc
rm -Rf spring-webmvc/src/main/java/org/springframework/web/servlet/view/tiles3
%pom_remove_dep :tiles-extras spring-webmvc
%pom_remove_dep org.apache.tiles: spring-webmvc
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%pom_remove_dep org.projectreactor: spring-messaging
rm -r spring-messaging/src/main/java/org/springframework/messaging/tcp/reactor \
 spring-messaging/src/main/java/org/springframework/messaging/simp/stomp/Reactor*.java
%patch10 -p1
%patch11 -p1

# https://pivotal.io/security/cve-2016-5007
sed -i.CVE-2015-5007 "s|private boolean trimTokens = true;|private boolean trimTokens = false;|" \
 spring-core/src/main/java/org/springframework/util/AntPathMatcher.java

# copy license and notice file
cp -p src/dist/* .

# Copy resources in non standard directory. Several projects (also test suite) use these resources
for p in context context-support web webmvc webmvc-portlet; do
 pushd spring-${p}
# clone source directory structure
  find src/main/java/ -type d | while read dirname ; do
   newdirname=`echo $dirname | sed "s:src/main/java:src/main/resources:g"`
   mkdir -p $newdirname
  done

# copy everything except *.java sources
  find src/main/java/ -type f | grep -v "\.java" | while read cpfrom ; do
   cpto=`echo $cpfrom | sed "s:src/main/java:src/main/resources:g"`
   cp $cpfrom $cpto
  done
 popd
done

for p in aop \
 beans \
 context \
 context-support \
 core \
 expression \
 instrument \
 jdbc \
 jms \
 messaging \
 orm \
 orm-hibernate4 \
 oxm \
 test \
 tx \
 web \
 webmvc \
 webmvc-portlet \
 websocket; do
 %pom_xpath_inject "pom:project" "<packaging>bundle</packaging>" spring-${p}
 %pom_add_plugin org.apache.felix:maven-bundle-plugin:2.5.4 spring-${p} "
 <extensions>true</extensions>
 <configuration>
   <excludeDependencies>true</excludeDependencies>
   <instructions>
     <Bundle-SymbolicName>\${project.groupId}.${p}</Bundle-SymbolicName>
     <Bundle-Name>\${project.name}</Bundle-Name>
     <Bundle-Version>\${project.version}</Bundle-Version>
   </instructions>
 </configuration>
 <executions>
   <execution>
     <id>bundle-manifest</id>
     <phase>process-classes</phase>
     <goals>
       <goal>manifest</goal>
     </goals>
   </execution>
 </executions>"
done

# Use system objectweb-asm
%pom_add_dep org.ow2.asm:asm:5.0.3 spring-context
mv spring-core/src/main/java/org/springframework/asm/SpringAsmInfo.java \
 spring-core/src/main/java/org/springframework/asm/SpringAsmInfo.java.save
find ./ -name "*.java" -exec sed -i "s/org.springframework.asm/org.objectweb.asm/g" {} +
rm spring-core/src/main/java/org/springframework/asm/*.java
mv spring-core/src/main/java/org/springframework/asm/SpringAsmInfo.java.save \
 spring-core/src/main/java/org/springframework/asm/SpringAsmInfo.java
find ./spring-core -name "*.java" -exec sed -i "s/org.objectweb.asm.SpringAsmInfo/org.springframework.asm.SpringAsmInfo/g" {} +
sed -i "s|Opcodes.ASM5|org.objectweb.asm.Opcodes.ASM5|" \
 spring-core/src/main/java/org/springframework/asm/SpringAsmInfo.java

# Use system cglib
%pom_add_dep net.sf.cglib:cglib:4.2 spring-core
sed -i "s|extends DefaultNamingPolicy|extends net.sf.cglib.core.DefaultNamingPolicy|" \
 spring-core/src/main/java/org/springframework/cglib/core/SpringNamingPolicy.java
find ./spring-beans -name "*.java" -exec sed -i "s/org.springframework.cglib.proxy/net.sf.cglib.proxy/g" {} +
find ./spring-aop -name "*.java" -exec sed -i "s/org.springframework.cglib.proxy/net.sf.cglib.proxy/g" {} +
sed -i "s|org.springframework.cglib.core.CodeGenerationException|net.sf.cglib.core.CodeGenerationException|" \
 spring-aop/src/main/java/org/springframework/aop/framework/CglibAopProxy.java
sed -i "s|org.springframework.cglib.transform.impl.UndeclaredThrowableStrategy|net.sf.cglib.transform.impl.UndeclaredThrowableStrategy|" \
 spring-aop/src/main/java/org/springframework/aop/framework/CglibAopProxy.java
find ./spring-context -name "*.java" -exec sed -i "s/org.springframework.cglib.proxy/net.sf.cglib.proxy/g" {} +
find ./spring-context -name "*.java" -exec sed -i "s/org.springframework.cglib.transform/net.sf.cglib.transform/g" {} +
sed -i "s|org.springframework.cglib.core.ClassGenerator|net.sf.cglib.core.ClassGenerator|" \
 spring-context/src/main/java/org/springframework/context/annotation/ConfigurationClassEnhancer.java
sed -i "s|org.springframework.cglib.core.Constants|net.sf.cglib.core.Constants|" \
 spring-context/src/main/java/org/springframework/context/annotation/ConfigurationClassEnhancer.java
sed -i "s|org.springframework.cglib.core.DefaultGeneratorStrategy|net.sf.cglib.core.DefaultGeneratorStrategy|" \
 spring-context/src/main/java/org/springframework/context/annotation/ConfigurationClassEnhancer.java
sed -i "s|org.springframework.cglib.core.Signature|net.sf.cglib.core.Signature|" \
 spring-context/src/main/java/org/springframework/scripting/support/ScriptFactoryPostProcessor.java
find ./spring-webmvc -name "*.java" -exec sed -i "s/org.springframework.cglib.proxy/net.sf.cglib.proxy/g" {} +

# Use system objenesis
%pom_add_dep org.objenesis:objenesis:2.1 spring-aop
sed -i "s|org.springframework.objenesis.ObjenesisStd|org.objenesis.ObjenesisStd|" \
 spring-aop/src/main/java/org/springframework/aop/framework/ObjenesisCglibAopProxy.java \
 spring-webmvc/src/main/java/org/springframework/web/servlet/mvc/method/annotation/MvcUriComponentsBuilder.java


# Default merge into spring-beans module
mv spring-beans-groovy/src/main/groovy spring-beans/src/main/
mv spring-beans-groovy/src/main/java/org/springframework/beans/factory/groovy \
 spring-beans/src/main/java/org/springframework/beans/factory/
%pom_add_plugin org.codehaus.gmavenplus:gmavenplus-plugin:1.5 spring-beans "
 <executions>
  <execution>
   <goals>
    <goal>generateStubs</goal>
    <goal>testGenerateStubs</goal>
   </goals>
  </execution>
 </executions>"

# ERROR: XThis is not public in Bsh
rm spring-context/src/main/java/org/springframework/scripting/bsh/BshScriptFactory.java
rm spring-context/src/main/java/org/springframework/scripting/bsh/BshScriptUtils.java

# Remove the dependency on WebSphere UOW as it is not open source and we will
# never be able to build it:
%pom_remove_dep com.ibm.websphere:uow spring-tx
rm spring-tx/src/main/java/org/springframework/transaction/jta/WebSphereUowTransactionManager.java \
 spring-tx/src/test/java/org/springframework/transaction/jta/WebSphereUowTransactionManagerTests.java

%if %{?fedora} < 25
# com.rometools:rome:1.5.1
find ./spring-web -name "*.java" -exec sed -i "s/com.rometools.rome/com.sun.syndication/g" {} +
%pom_change_dep :rome rome: spring-web
find ./spring-webmvc -name "*.java" -exec sed -i "s/com.rometools.rome/com.sun.syndication/g" {} +
%pom_change_dep :rome rome: spring-webmvc
%endif

%pom_change_dep org.eclipse.persistence:javax.persistence org.hibernate.javax.persistence:hibernate-jpa-2.1-api spring-context
# package javax.interceptor does not exist
%pom_add_dep org.apache.geronimo.specs:geronimo-interceptor_3.0_spec:1.0.1  spring-context

%pom_change_dep javax.validation:validation-api org.apache.geronimo.specs:geronimo-validation_1.0_spec:1.1 spring-context

%pom_change_dep javax.resource:connector-api org.jboss.spec.javax.resource:jboss-connector-api_1.7_spec:1.0.0.Final spring-tx
%pom_change_dep javax.faces:javax.faces-api org.jboss.spec.javax.faces:jboss-jsf-api_2.2_spec:2.2.0 spring-web

%pom_change_dep :openjpa org.apache.openjpa:openjpa-lib:2.4.0 spring-orm
%pom_add_dep org.apache.openjpa:openjpa-persistence-jdbc:2.4.0 spring-orm

%pom_change_dep org.eclipse.persistence:javax.persistence org.hibernate.javax.persistence:hibernate-jpa-2.1-api spring-orm

# do not generate R on hiberante4, we use version 3
%pom_remove_dep :hibernate-entitymanager spring-orm
%pom_add_dep org.hibernate:hibernate-entitymanager:3 spring-orm
%pom_remove_dep :hibernate-core spring-orm
%pom_add_dep org.hibernate:hibernate-core:3 spring-orm

%pom_change_dep javax.cache:cache-api org.apache.geronimo.specs:geronimo-jcache_1.0_spec:1.0-alpha-1 spring-context-support
%pom_change_dep org.codehaus.fabric3.api:commonj org.apache.geronimo.specs:geronimo-commonj_1.1_spec:1.1.0 spring-context-support

%pom_change_dep :connector-api org.jboss.spec.javax.resource:jboss-connector-api_1.7_spec:1.0.0.Final spring-jms
%pom_change_dep javax.jms:jms-api org.apache.geronimo.specs:geronimo-jms_1.1_spec:1.1.1 spring-jms

%pom_change_dep javax.servlet.jsp.jstl:javax.servlet.jsp.jstl-api org.apache.taglibs:taglibs-standard-spec:1.2.5 spring-webmvc
%pom_change_dep javax.servlet.jsp.jstl:javax.servlet.jsp.jstl-api org.apache.taglibs:taglibs-standard-spec:1.2.5 spring-test

# Use old Undertow release
%pom_remove_dep io.undertow:  spring-websocket
rm  spring-websocket/src/main/java/org/springframework/web/socket/server/standard/UndertowRequestUpgradeStrategy.java \
 spring-websocket/src/main/java/org/springframework/web/socket/sockjs/client/UndertowXhrTransport.java

%pom_change_dep :ehcache net.sf.ehcache.internal:ehcache-core:2.10 spring-context-support

%mvn_compat_version : %{namedversion} %{version} 4

%mvn_package :spring-project __noinstall

%build

# Build without the tests, as they bring a lot of dependecies that are not
# available in the distribution at the moment:
%mvn_build -fs -- -Dproject.build.sourceEncoding=UTF-8

%install
%mvn_install

%files aop -f .mfiles-spring-aop
%files beans -f .mfiles-spring-beans
%files context -f .mfiles-spring-context
%files context-support -f .mfiles-spring-context-support
%files core -f .mfiles-spring-core
%doc README.md readme.txt
%license license.txt  notice.txt

%files expression -f .mfiles-spring-expression
%files instrument -f .mfiles-spring-instrument
%license license.txt  notice.txt

%files jdbc -f .mfiles-spring-jdbc
%files jms -f .mfiles-spring-jms
%files messaging -f .mfiles-spring-messaging
%files orm -f .mfiles-spring-orm
%files orm-hibernate4 -f .mfiles-spring-orm-hibernate4
%files oxm -f .mfiles-spring-oxm
%files test -f .mfiles-spring-test
%files tx -f .mfiles-spring-tx
%files web -f .mfiles-spring-web
%files webmvc -f .mfiles-spring-webmvc
%files webmvc-portlet -f .mfiles-spring-webmvc-portlet
%files websocket -f .mfiles-spring-websocket

%files javadoc -f .mfiles-javadoc
%license license.txt  notice.txt

%changelog
* Mon Jul 11 2016 gil cattaneo <puntogil@libero.it> 4.1.9-1
- initial rpm

